---
layout: slides
title: Why Python?
subtitle: Motivation
---
## Python is...

- popular,
- powerful,
- easy to learn
- programming language
- that is human readable,
- free,
- and open source.


## Libraries

It has excellent libraries for

- mathematics
- plotting,
- and domain sciences.


## Tasks that Python could help you do:

- Transform your data files from one arbitrary format to another.
- Analyze image files.
- Loop through all the files in a directory, perform an analysis on them, and plot the results.
- **Almost anything!**


## Packages

Contain extensions to the language for specific tasks.
The Python Package Index has more than 48k packages,
including some for:

- analyzing biological sequence data,
- numerical analyses,
- plotting,
- and much more.


## Why Python and not ...

**Perl?** →  Python is easier to read and learn.

**Javascript or Ruby?** →  Python has more good numerical libraries.

**MATLAB or SAS?** →  Python is free.

**R?** →  Depends on the task at hand. R has some advantages in statistics and
  visualization, but Python is a more flexible option that can perform
  many different tasks well.


## IPython notebook

![IPython notebook screenshot](img/ipython-notebook.png)


## IPython notebook

An interactive shell for using Python.

- Browser based notebooks to organize and display code
- Simplifies data visualization
- Makes it easy to share whole analysis pipelines


## Learn More

- [python.org](https://www.python.org/)
- [ipython.org](http://ipython.org/)
